package ru.landgrafhomyak.serdha.api.v0.ddl

import kotlin.jvm.JvmField
import kotlinx.datetime.Instant
import kotlinx.datetime.LocalDate
import kotlinx.datetime.LocalDateTime
import kotlinx.datetime.LocalTime

@OptIn(ExperimentalUnsignedTypes::class)
@Suppress("ClassName", "RemoveRedundantQualifierName")
public interface ColumnType<@Suppress("unused") RuntimeType> {
	public val typeName: String

	@Suppress("FunctionName", "PropertyName")
	public interface Builder {
		public fun <TableUserExtension : Any> ROW_ID(): ColumnType<RowId<TableUserExtension>>

		public val BOOLEAN: ColumnType.BOOLEAN

		public val INT_S8: ColumnType.INT_S8

		public val INT_U8: ColumnType.INT_U8

		public val INT_S16: ColumnType.INT_S16

		public val INT_U16: ColumnType.INT_U16

		public val INT_S32: ColumnType.INT_S32

		public val INT_U32: ColumnType.INT_U32

		public val INT_S64: ColumnType.INT_S64

		public val INT_U64: ColumnType.INT_U64

		public val LOCAL_DATE: ColumnType.LOCAL_DATE

		public val LOCAL_TIME: ColumnType.LOCAL_TIME

		public val LOCAL_DATETIME: ColumnType.LOCAL_DATETIME

		public val INSTANT: ColumnType.INSTANT

		public val FLOAT_32: ColumnType.FLOAT_32

		public val FLOAT_64: ColumnType.FLOAT_64

		public val STRING: ColumnType.STRING
		public fun STRING(size: UInt): ColumnType.STRING

		public val BYTE_ARRAY: ColumnType.BYTE_ARRAY
		public fun BYTE_ARRAY(size: UInt): ColumnType.BYTE_ARRAY

		public fun <R : Any, D : ColumnType<R>> nullableOf(d: D): Nullable<R, D>
	}

	public abstract class _VirtualType<R : Any>(@Suppress("MemberVisibilityCanBePrivate") @JvmField public val wraps: ColumnType<R>)

	public interface Nullable<R : Any, @Suppress("unused") D : ColumnType<R>> : ColumnType<R?>

	public interface ROW_ID : ColumnType<RowId<*>>

	public interface BOOLEAN : ColumnType<Boolean>

	public interface INT_S8 : ColumnType<Byte>

	public interface INT_U8 : ColumnType<UByte>

	public interface INT_S16 : ColumnType<Short>

	public interface INT_U16 : ColumnType<UShort>

	public interface INT_S32 : ColumnType<Int>

	public interface INT_U32 : ColumnType<UInt>

	public interface INT_S64 : ColumnType<Long>

	public interface INT_U64 : ColumnType<ULong>

	public interface LOCAL_DATE : ColumnType<LocalDate>

	public interface LOCAL_TIME : ColumnType<LocalTime>

	public interface LOCAL_DATETIME : ColumnType<LocalDateTime>

	public interface INSTANT : ColumnType<Instant>

	public interface FLOAT_32 : ColumnType<Float>

	public interface FLOAT_64 : ColumnType<Double>

	public interface STRING : ColumnType<String>

	public interface BYTE_ARRAY : ColumnType<UByteArray>
}
