package ru.landgrafhomyak.serdha.api.v0.ddl

public interface ModuleTemplate<ModuleUserExtension : Any> {
	public interface CreateModule<ModuleUserExtension : Any> {
		public fun createModule(oldModule: ModuleTemplate<ModuleUserExtension>, rootNs: Namespace, updater: ModuleCreator): ModuleUserExtension
	}

	public interface UpgradeModule<OldModuleUserExtension : Any, NewModuleUserExtension : Any> {
		public fun createModule(oldModule: ModuleTemplate<OldModuleUserExtension>, rootNs: Namespace, updater: ModuleCreator): NewModuleUserExtension
	}

	public fun <NewModuleUserExtension : Any> upgrade(
		newVersionKey: String,
		updater: UpgradeModule<ModuleUserExtension, NewModuleUserExtension>
	): ModuleTemplate<NewModuleUserExtension>

	public val versionKey: String
}