package ru.landgrafhomyak.serdha.api.v0.ddl

import ru.landgrafhomyak.serdha.api.v0.Expression


public interface TableUpdater<TableNewUserExtension : Any, TableOldUserExtension : Any> : TableCreator<TableNewUserExtension> {
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> keepColumn(c: Column<RuntimeType, DatabaseType, TableOldUserExtension>): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> renameColumn(c: Column<RuntimeType, DatabaseType, TableOldUserExtension>, newName: String): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapColumn(c: Column<RuntimeType, DatabaseType, TableNewUserExtension>, newValue: Expression<RuntimeType, DatabaseType, TableNewUserExtension>, where: Expression<Boolean, ColumnType.BOOLEAN, TableNewUserExtension>?)
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapColumn(c: Column<RuntimeType, DatabaseType, TableNewUserExtension>, newValue: Expression<RuntimeType, DatabaseType, TableNewUserExtension>): Unit = this.mapColumn(c, newValue, null)
	public fun deleteColumn(c: Column<*, *, TableOldUserExtension>)

	public fun keepIndex(i: Index<TableOldUserExtension>): Index<TableNewUserExtension>
	public fun renameIndex(i: Index<TableOldUserExtension>, newName: String): Index<TableNewUserExtension>
	public fun deleteIndex(i: Index<TableOldUserExtension>)

	public fun keepCheck(i: CheckConstraint<TableOldUserExtension>): CheckConstraint<TableNewUserExtension>
	public fun renameCheck(i: CheckConstraint<TableOldUserExtension>, newName: String): CheckConstraint<TableNewUserExtension>
	public fun deleteCheck(i: CheckConstraint<TableOldUserExtension>)

	public fun keepUnique(i: UniqueConstraint<TableOldUserExtension>): UniqueConstraint<TableNewUserExtension>
	public fun renameUnique(i: UniqueConstraint<TableOldUserExtension>, newName: String): UniqueConstraint<TableNewUserExtension>
	public fun deleteUnique(i: UniqueConstraint<TableOldUserExtension>)

	public fun <TargetTableOldUserWrapper : Any, TargetTableNewUserWrapper : Any> keepForeignKeyToUpdatedTable(i: ForeignKey<TableOldUserExtension, TargetTableOldUserWrapper>, updatedTable: Table<TargetTableNewUserWrapper, TargetTableOldUserWrapper>): ForeignKey<TableNewUserExtension, TargetTableNewUserWrapper>
	public fun <TargetTableUserWrapper : Any> keepForeignKey(i: ForeignKey<TableOldUserExtension, TargetTableUserWrapper>): ForeignKey<TableNewUserExtension, TargetTableUserWrapper>
	public fun <TargetTableOldUserWrapper : Any, TargetTableNewUserWrapper : Any> renameForeignKeyToUpdatedTable(i: ForeignKey<TableOldUserExtension, TargetTableOldUserWrapper>, updatedTable: Table<TargetTableNewUserWrapper, TargetTableOldUserWrapper>): ForeignKey<TableNewUserExtension, TargetTableNewUserWrapper>
	public fun <TargetTableUserWrapper : Any> renameForeignKey(i: ForeignKey<TableOldUserExtension, TargetTableUserWrapper>): ForeignKey<TableNewUserExtension, TargetTableUserWrapper>
	public fun deleteForeignKey(i: ForeignKey<TableOldUserExtension, *>)
}