package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.ColumnType
import ru.landgrafhomyak.serdha.api.v0.ddl.Table

public interface UpdateCreator<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonQueryMethods<QueryUserExtension> {
	public val targetTable: SelectedTable<TargetTableUserExtension, QueryUserExtension>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> selectOldColumnValue(c: Column<RuntimeType, DatabaseType, TargetTableUserExtension>): Expression<RuntimeType, DatabaseType, QueryUserExtension>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> updateColumn(c: Column<RuntimeType, DatabaseType, TargetTableUserExtension>, e: Expression<RuntimeType, DatabaseType, QueryUserExtension>)

	public fun where(expression: Expression<Boolean, ColumnType.BOOLEAN, QueryUserExtension>)

	public fun limit(size: UInt)

	@Suppress("SpellCheckingInspection")
	public fun offsetedLimit(offset: ULong, size: UInt)

	public fun returning(s: (_CommonQueryMethods._Returning<QueryUserExtension>) -> Unit)
}