package ru.landgrafhomyak.serdha.api.v0.runtime

import ru.landgrafhomyak.serdha.api.v0.dml.InputParam

public interface ParametersSetter<QueryUserExtension : Any> {
	public operator fun <RuntimeType> set(c: InputParam<RuntimeType, *, QueryUserExtension>, value: RuntimeType)

	public operator fun set(c: InputParam<Byte, *, QueryUserExtension>, value: Byte): Unit = this.set<Byte>(c, value)
	public operator fun set(c: InputParam<UByte, *, QueryUserExtension>, value: UByte): Unit = this.set<UByte>(c, value)
	public operator fun set(c: InputParam<Short, *, QueryUserExtension>, value: Short): Unit = this.set<Short>(c, value)
	public operator fun set(c: InputParam<UShort, *, QueryUserExtension>, value: UShort): Unit = this.set<UShort>(c, value)
	public operator fun set(c: InputParam<Int, *, QueryUserExtension>, value: Int): Unit = this.set<Int>(c, value)
	public operator fun set(c: InputParam<UInt, *, QueryUserExtension>, value: UInt): Unit = this.set<UInt>(c, value)
	public operator fun set(c: InputParam<Long, *, QueryUserExtension>, value: Long): Unit = this.set<Long>(c, value)
	public operator fun set(c: InputParam<ULong, *, QueryUserExtension>, value: ULong): Unit = this.set<ULong>(c, value)
	public operator fun set(c: InputParam<Char, *, QueryUserExtension>, value: Char): Unit = this.set<Char>(c, value)
	public operator fun set(c: InputParam<Boolean, *, QueryUserExtension>, value: Boolean): Unit = this.set<Boolean>(c, value)
}